=== modified file 'drizzled/catalog/local.cc'
--- drizzled/catalog/local.cc	2011-09-18 17:33:22 +0000
+++ drizzled/catalog/local.cc	2011-12-27 06:49:23 +0000
@@ -1,7 +1,7 @@
 /* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
  *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
  *
- *  Copyright (C) 2010 Brian Aker
+ *  Copyright (C) 2010-2011 Brian Aker, Stewart Smith
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -42,6 +42,14 @@
   return default_catalog;
 }
 
+void resetPath_for_local_identifier()
+{
+  /* this is currently commented out to do nothing as we don't need
+     to reset the relative path ../local to anything but that.
+     We will need to enable this when we don't chdir into local on startup */
+//  default_catalog.resetPath();
+}
+
 Instance::shared_ptr local()
 {
   boost::call_once(&init, run_once);

=== modified file 'drizzled/catalog/local.h'
--- drizzled/catalog/local.h	2011-03-23 23:34:24 +0000
+++ drizzled/catalog/local.h	2011-12-27 06:49:23 +0000
@@ -1,7 +1,7 @@
 /* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
  *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
  *
- *  Copyright (C) 2010 Brian Aker
+ *  Copyright (C) 2010-2011 Brian Aker, Stewart Smith
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -28,6 +28,9 @@
 namespace drizzled {
 namespace catalog {
 
+/* only for use by drizzled after command line parsing (new datadir) */
+void resetPath_for_local_identifier();
+
 DRIZZLED_API const identifier::Catalog& local_identifier();
 DRIZZLED_API Instance::shared_ptr local();
 

=== modified file 'drizzled/data_home.cc'
--- drizzled/data_home.cc	2011-06-16 15:27:28 +0000
+++ drizzled/data_home.cc	2011-12-27 06:49:23 +0000
@@ -1,7 +1,7 @@
 /* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
  *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
  *
- *  Copyright (C) 2011 Brian Aker
+ *  Copyright (C) 2011 Brian Aker, Stewart Smith
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -22,12 +22,12 @@
 #include <boost/filesystem.hpp>
 #include <drizzled/configmake.h>
 #include <drizzled/data_home.h>
+#include <drizzled/catalog.h>
 
 namespace drizzled {
 
 static boost::filesystem::path data_home(LOCALSTATEDIR);
 static boost::filesystem::path full_data_home(LOCALSTATEDIR);
-static boost::filesystem::path data_home_catalog(LOCALSTATEDIR);
 
 const boost::filesystem::path& getFullDataHome()
 {
@@ -39,11 +39,6 @@
   return data_home;
 }
 
-const boost::filesystem::path& getDataHomeCatalog()
-{
-  return data_home_catalog;
-}
-
 boost::filesystem::path& getMutableDataHome()
 {
   return data_home;
@@ -54,9 +49,4 @@
   full_data_home= v;
 }
 
-void setDataHomeCatalog(const boost::filesystem::path& v)
-{
-  data_home_catalog= v;
-}
-
 } // namespace drizzled

=== modified file 'drizzled/data_home.h'
--- drizzled/data_home.h	2011-06-16 15:27:28 +0000
+++ drizzled/data_home.h	2011-12-27 06:49:23 +0000
@@ -26,10 +26,8 @@
 
 DRIZZLED_API const boost::filesystem::path& getFullDataHome();
 DRIZZLED_API const boost::filesystem::path& getDataHome();
-DRIZZLED_API const boost::filesystem::path& getDataHomeCatalog();
 DRIZZLED_API boost::filesystem::path& getMutableDataHome();
 DRIZZLED_API void setFullDataHome(const boost::filesystem::path&);
-DRIZZLED_API void setDataHomeCatalog(const boost::filesystem::path&);
 
 } /* namespace drizzled */
 

=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2011-11-22 14:53:10 +0000
+++ drizzled/drizzled.cc	2011-12-27 06:49:23 +0000
@@ -1977,7 +1977,7 @@
 */
 static void get_options()
 {
-  setDataHomeCatalog(getDataHome() / "local");
+  catalog::resetPath_for_local_identifier();
 
   if (vm.count("user"))
   {

=== modified file 'drizzled/function/str/load_file.cc'
--- drizzled/function/str/load_file.cc	2011-06-22 22:23:29 +0000
+++ drizzled/function/str/load_file.cc	2011-12-27 06:49:23 +0000
@@ -2,6 +2,7 @@
  *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
  *
  *  Copyright (C) 2008 Sun Microsystems, Inc.
+ *  Copyright (C) 2011 Stewart Smith
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +22,7 @@
 #include <drizzled/function/str/strfunc.h>
 #include <drizzled/function/str/load_file.h>
 #include <drizzled/error.h>
-#include <drizzled/data_home.h>
+#include <drizzled/catalog/local.h>
 #include <drizzled/session.h>
 #include <drizzled/internal/my_sys.h>
 #include <drizzled/sys_var.h>
@@ -52,7 +53,7 @@
     return 0;
   }
 
-  fs::path target_path(fs::system_complete(getDataHomeCatalog()));
+  fs::path target_path(fs::system_complete(catalog::local_identifier().getPath()));
   fs::path to_file(file_name->c_ptr());
   if (not to_file.has_root_directory())
   {

=== modified file 'drizzled/identifier/catalog.h'
--- drizzled/identifier/catalog.h	2011-09-18 17:33:22 +0000
+++ drizzled/identifier/catalog.h	2011-12-27 06:49:23 +0000
@@ -81,6 +81,12 @@
   {
     return boost::iequals(left.getName(), right.getName());
   }
+
+  void resetPath()
+  {
+    init();
+  }
+
 private:
   void init();
 

=== modified file 'drizzled/session.cc'
--- drizzled/session.cc	2011-11-09 20:20:23 +0000
+++ drizzled/session.cc	2011-12-27 06:49:23 +0000
@@ -27,7 +27,7 @@
 #include <boost/filesystem.hpp>
 #include <boost/ptr_container/ptr_container.hpp>
 #include <drizzled/copy_field.h>
-#include <drizzled/data_home.h>
+#include <drizzled/catalog/local.h>
 #include <drizzled/diagnostics_area.h>
 #include <drizzled/display.h>
 #include <drizzled/drizzled.h>
@@ -996,7 +996,7 @@
 
   if (not to_file.has_root_directory())
   {
-    target_path= fs::system_complete(getDataHomeCatalog());
+    target_path= fs::system_complete(catalog::local_identifier().getPath());
     util::string::ptr schema(session.schema());
     if (not schema->empty())
     {

=== modified file 'drizzled/sql_load.cc'
--- drizzled/sql_load.cc	2011-10-18 11:01:40 +0000
+++ drizzled/sql_load.cc	2011-12-27 06:49:23 +0000
@@ -1,4 +1,5 @@
 /* Copyright (C) 2000-2006 MySQL AB
+   Copyright (C) 2011 Stewart Smith
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
@@ -20,7 +21,7 @@
 
 #include <drizzled/sql_load.h>
 #include <drizzled/error.h>
-#include <drizzled/data_home.h>
+#include <drizzled/catalog/local.h>
 #include <drizzled/session.h>
 #include <drizzled/sql_base.h>
 #include <drizzled/field/epoch.h>
@@ -263,7 +264,7 @@
   }
 
   fs::path to_file(ex->file_name);
-  fs::path target_path(fs::system_complete(getDataHomeCatalog()));
+  fs::path target_path(fs::system_complete(catalog::local_identifier().getPath()));
   if (not to_file.has_root_directory())
   {
     int count_elements= 0;

=== modified file 'plugin/innobase/handler/ha_innodb.cc'
--- plugin/innobase/handler/ha_innodb.cc	2011-11-09 20:20:23 +0000
+++ plugin/innobase/handler/ha_innodb.cc	2011-12-27 06:49:23 +0000
@@ -3,6 +3,7 @@
 Copyright (C) 2000, 2010, MySQL AB & Innobase Oy. All Rights Reserved.
 Copyright (C) 2008, 2009 Google Inc.
 Copyright (C) 2009, Percona Inc.
+Copyright (C) 2011, Stewart Smith
 
 Portions of this file contain modifications contributed and copyrighted by
 Google, Inc. Those modifications are gratefully acknowledged and are described
@@ -50,6 +51,7 @@
 #include <drizzled/plugin.h>
 #include <drizzled/show.h>
 #include <drizzled/data_home.h>
+#include <drizzled/catalog/local.h>
 #include <drizzled/error.h>
 #include <drizzled/field.h>
 #include <drizzled/charset.h>
@@ -7287,7 +7289,7 @@
 
     prebuilt->trx->op_info = "returning various info to MySQL";
 
-    fs::path get_status_path(getDataHomeCatalog());
+    fs::path get_status_path(catalog::local_identifier().getPath());
     get_status_path /= ib_table->name;
     fs::change_extension(get_status_path, "dfe");
 

=== modified file 'plugin/schema_engine/schema.cc'
--- plugin/schema_engine/schema.cc	2011-10-18 13:52:19 +0000
+++ plugin/schema_engine/schema.cc	2011-12-27 06:49:23 +0000
@@ -26,7 +26,7 @@
 #include <drizzled/sql_table.h>
 #include <drizzled/charset.h>
 #include <drizzled/cursor.h>
-#include <drizzled/data_home.h>
+#include <drizzled/catalog/local.h>
 
 #include <drizzled/pthread_globals.h>
 
@@ -71,7 +71,9 @@
 
 void Schema::prime()
 {
-  CachedDirectory directory(getDataHomeCatalog().file_string(), CachedDirectory::DIRECTORY);
+  CachedDirectory directory(catalog::local_identifier().getPath(),
+                            CachedDirectory::DIRECTORY, true);
+
   CachedDirectory::Entries files= directory.getEntries();
   boost::unique_lock<boost::shared_mutex> scopedLock(mutex);
 
@@ -80,7 +82,12 @@
     if (not entry->filename.compare(GLOBAL_TEMPORARY_EXT))
       continue;
     message::Schema schema_message;
-    if (readSchemaFile(entry->filename, schema_message))
+
+    std::string filename= catalog::local_identifier().getPath();
+    filename+= FN_LIBCHAR;
+    filename+= entry->filename;
+
+    if (readSchemaFile(filename, schema_message))
     {
       identifier::Schema schema_identifier(schema_message.name());
 

